DCMTK - Bug #687

Minor bug in DCMJPLS encoder
2016-06-02 13:49 - Marco Eichelberg

Status: Closed Start date: 2016-06-02
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0:00 hour
Target version: 3.6.2

Module: dcmijpls Compiler:

Operating System:

Description

In 2014, our team discovered an overflow bug in the CharLS encoder and submitted a patch [[
http://charls.codeplex.com/workitem/10742]] that was also included in DCMJPLS (dcmijpls/libcharls/encodstr.h). However, according
to Mathieu Malaterre, the patch does not solve all cases, and needs further modification as follows:

-—— a/dcmjpls/libcharls/encodstr.h
+++ b/dcmijpls/libcharls/encodstr.h
@@ -70,17 +70,23 @Q protected:

#fendif
bitpos —-= length;
- if (bitpos > 0)
+ if (bitpos >= 0)
{
valcurrent = valcurrent | (value << bitpos);
return;
}
o]
valcurrent |= value >> -bitpos;
+ Flush{();
+ // A second flush may be required if extra marker-detect bits were needed and not all bits c
ould be written.
+ if (bitpos < 0)
+ {
i valcurrent |= value >> -bitpos;
Flush{();
+ }

ASSERT (bitpos >=0);
- if (bitpos < 32)
valcurrent |= value << bitpos;

@@ -107,7 +113,7 @Q protected:

if (_isFFWritten)
{
= // insert highmost bit
+ // JPEG-LS requirement (T.87, A.l) to detect markers: after a xFF value a single 0 bit ne
eds to be inserted.
*_position = BYTE (valcurrent >> 25);
valcurrent = valcurrent << 7;
bitpos += 7;

The patch compiles in DCMTK, but needs some testing before being committed.

History

#1 - 2016-06-03 10:02 - Marco Eichelberg
http://charls.codeplex.com/workitem/10742

- Status changed from New to Closed

Checked the patch with a large set of 20,000 files containing various SOP classes.
Apparently the patch changes the compressed JPEG-LS bitstream, but after decompression
the pixel data is always correct. Committed with commit b6¢c821c95825a94b033e871da654dc46e2c118f6.
